/*
 * Created on Jan 31, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package example;

import java.io.*;
import java.net.*;

/**
 * @author aldrich
 */
public class TaintedExample {
	
	/** Models a library function that gets data from
	 * an untrusted source
	 * 
	 * @tainted
	 */
	String getTaintedInput() {
		return "some-tainted-string";
	}
	
	/** Models a library function that executes a command
	 * in a way that could be dangerous if that command came
	 * from unvalided data from an untrusted source
	 * 
	 * @notTainted command
	 */
	void execute(String command) {
		// executes command in the OS
	}

	/** A field that holds possibly-tainted data.
	 * 
	 * @tainted
	 */
	String imTainted;

	/** Filters the field imTainted, matching it against an
	 * expected format (in this case, just a string of
	 * letters and digits) and thus converting tainted data
	 * into untainted data.
	 * 
	 * @notTainted
	 */
	String filter() throws IOException {
		String safe = "safe";
		String dangerous = safe.concat(imTainted);
		String alsoDangerous = dangerous;
		if (alsoDangerous.matches("\\w*"))
			return alsoDangerous;
		else
			return "replace dangerous command with safe one";
	}
	
	/** Executes a command that has been verified to be
	 * untainted.
	 * 
	 * @notTainted command
	 */
	void executeUntaintedCommand(String command) {
		execute(command);
	}

	/** The main loop of the program
	 */
	void run() throws IOException {
		imTainted = getTaintedInput();
		String command = filter();
		executeUntaintedCommand(command);
	}
}
